/**
 * Copyright 2016-2019 Cloudera, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 **/

package com.hortonworks.registries.cache;

import com.hortonworks.registries.cache.view.config.ExpiryPolicy;

public abstract class AbstractCache<K, V> implements Cache<K, V> {
    protected final ExpiryPolicy expiryPolicy;

    public AbstractCache() {
        this(null);
    }

    public AbstractCache(ExpiryPolicy expiryPolicy) {
        this.expiryPolicy = expiryPolicy;
    }

    @Override
    public ExpiryPolicy getExpiryPolicy() {
        return expiryPolicy;
    }

    @Override
    public String toString() {
        return "AbstractCache{" +
                "expiryPolicy=" + expiryPolicy +
                '}';
    }
}
